(function (d3) {
  
  
  
const svg = d3.select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');
/*var margin = {
  left: 80,
  top: 10,
  bottom: 100,
  right: 10,
};

const x = d3.scaleBand().range([
  margin.left,
  width - margin.right - margin.right,
]);
var xAx = svg
  .append('g')
  .attr(
    'transform',
    'translate(' + margin.left + ',0)'
  );

const y = d3.scaleLinear().range([
  height - margin.bottom,
  margin.top,
]);
var yAx = svg
  .append('g')
  .attr(
    'transform',
    'translate(' + margin.left + ',0)'
  );*/
  
  
  

  
  
  

function update(data) {
  
  //Creating Line graph
	const render = data => { 
  //Declaring constants we are using
  const title = 'Test';
  
  const xValue = d => d.Year; //display dates on x axis
  const xAxisLabel = 'Date';

  const yValue = d => d.Sales; //display salees value on y axis
  const yAxisLabel = 'Nombre de musique';
  
  const margin = { top: 60, right: 40, bottom: 88, left: 150 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  //container
  
  
  //center g in svg
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
  
  // Create X scale with year values
  const xScale = d3.scaleTime()
  //complete set of values
    .domain(d3.extent(data, xValue)) 
  //returns the minimum and maximum value in an array from the given array using natural order.
    .range([0, innerWidth]) //output bounds
    .nice(); //round values out
  //creating xAxis  
  const xAxis = d3.axisBottom(xScale)
    .tickSize(-innerHeight)
    .tickPadding(15);
  
  // Create Y scale with sales values
  const yScale = d3.scaleLinear()
    .domain([0, d3.max(data, yValue )])
    .range([innerHeight, 0])
    .nice();
  
  //creating yAxis  
  const yAxis = d3.axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(10);
  
  //Appending Y axis label to svg
  const yAxisG = g.append('g').call(yAxis);
  	yAxisG.selectAll('.domain').remove();
  	yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -90)
      .attr('x', -innerHeight / 3)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .text(yAxisLabel);
  
  //Appending X axis label to svg
  const xAxisG = g.append('g').call(xAxis)
    	.attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 70)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabel);
  }
  
  
  
  
  
  
  
  /*x.domain(newData.map((d) => d.date));
  xAx
    .call(d3.axisBottom(x))
    .attr('transform', 'translate(0, 410)')
    .selectAll('text')
    .style('text-anchor', 'end')
    .attr('dx', '-1em')
    .attr('dy', '-0.5em')
    .attr('transform', 'rotate(-60)');

  y.domain([
    0,
    max(data, (d) => +d.nb_musique),
  ]);
  yAx.call(d3.axisLeft(y).tickSize(-width));

  // Add the line
    svg.append("path")
      .datum(data)
      .attr("fill", "none")
      .attr("stroke", "steelblue")
      .attr("stroke-width", 1.5)
      .attr("d", d3.line()
        .x(function(d) { return x(d.date) })
        .y(function(d) { return y(d.nb_musique) })
        )*/


};
  
  
  
  
  
  /*let newData = new Array();
  d3.json("data.json").then((data) => { 
  let i = 0;
  //Trier les données
  data.forEach(function(d){    
    let isPresent = false;
  	let j = 0;
    let index;
    newData.forEach(function(dd){      
      if(newData[j].genre == data[i].genre){
        isPresent = true;
        index = j;
      }      
    	j++;
    });
    
    if(isPresent){
      newData[index].nb_musique = newData[index].nb_musique+1;
    }
    else{
      
      if(!data[i].genre ==""){
        if(!data[i].dateRelease ==""){
          const date = new Date(data[i].dateRelease);
          newData.push({
                 "genre": data[i].genre,
                 "date": date.getFullYear(),
            		 "nb_musique" : 1
          });
        }
      }
    }
    isPresent = false;
    i++;
    
    //Trier les dates par ordre croissant 
  	newData.sort(function (a, b) {
            return d3['ascending'](
              +a.date,
              +b.date
            );
    })
    
  });
    
  
  console.log(newData);
  
	update(newData);
    
  });*/
  
  csv('https://gist.githubusercontent.com/ravitejabonam/420ad606e38a2ec1b233fb9a15ac8f2d/raw/747074a1250e5f1a2bfdcc3fef4349ac5c1eb247/US_TOTAL_AUTOMOTIVE_SALES_ANNUALLY.csv')
  .then(data => {
  	//console.log(data)
    data.forEach(d => {
    	d.Sales = +d.Sales;
      d.Year = new Date(d.Year)
    });
    console.log(data);
    render(data);
  });
  
  
}(d3))